/*
 * Copyright 2014 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package at.jku.risc.stout.urauc;

import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;

import at.jku.risc.stout.urauc.algo.AlignFnc;
import at.jku.risc.stout.urauc.algo.AlignFncLAA;
import at.jku.risc.stout.urauc.algo.AntiUnify;
import at.jku.risc.stout.urauc.algo.AntiUnifyProblem;
import at.jku.risc.stout.urauc.algo.AntiUnifySystem;
import at.jku.risc.stout.urauc.algo.DebugLevel;
import at.jku.risc.stout.urauc.algo.JustificationException;
import at.jku.risc.stout.urauc.data.EquationSystem;
import at.jku.risc.stout.urauc.data.InputParser;
import at.jku.risc.stout.urauc.data.atom.Variable;
import at.jku.risc.stout.urauc.util.ControlledException;

public class TestPaperExample {

	public static void main(String[] args) throws IOException,
			JustificationException, ControlledException {
		Reader in1 = new StringReader("a,f(b,a,a),a"); // Use FileReader instead
		Reader in2 = new StringReader("f(a,a,b)"); // Use FileReader instead

		AlignFnc aFnc = new AlignFncLAA();
		EquationSystem<AntiUnifyProblem> eqSys = new EquationSystem<AntiUnifyProblem>() {
			public AntiUnifyProblem newEquation() {
				return new AntiUnifyProblem();
			}
		};

		new InputParser<>(eqSys).parseHedgeEquation(in1, in2);

		new AntiUnify(aFnc, eqSys, DebugLevel.SILENT) {
			public void callback(AntiUnifySystem res, Variable var) {
				System.out.println(res.getSigma().get(var));
			}
		}.antiUnify(true, false, null);
	}

}
