package at.jku.risc.stout.urauc.algo;

import java.io.PrintStream;

import at.jku.risc.stout.urauc.algo.AlignFnc.AlignmentIterator;
import at.jku.risc.stout.urauc.data.Alignment;

public class AlignFncInput extends AlignFnc implements AlignmentIterator {
	private boolean hasNext = true;
	private Alignment alignment;

	/**
	 * The alignment must be admissible.
	 */
	public void setAlignment(Alignment alignment) {
		this.alignment = alignment;
	}

	@Override
	public boolean hasNext() {
		return hasNext;
	}

	@Override
	public Alignment next() {
		hasNext = false;
		return alignment;
	}

	@Override
	public AlignmentIterator getIterator(AntiUnifyProblem aup, int minAlignLen,
			int upperBound, boolean iterateAll, PrintStream out) {
		hasNext = (minAlignLen <= getMaxAlignmentLen());
		return this;
	}

	@Override
	public int getMaxAlignmentLen() {
		return alignment.size();
	}

	@Override
	public AlignFnc newInstance() {
		AlignFncInput aNew = new AlignFncInput();
		aNew.setAlignment(alignment);
		return aNew;
	}

	@Override
	public int getCommutativeArrangementSize() {
		return 1;
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException("Remove is not supported.");
	}
}
