package at.jku.risc.stout.urauc.algo;

import java.io.PrintStream;
import java.util.List;

import at.jku.risc.stout.urauc.algo.AntiUnifyProblem.VariableWithHedges;
import at.jku.risc.stout.urauc.data.EquationSystem;
import at.jku.risc.stout.urauc.data.Hedge;
import at.jku.risc.stout.urauc.data.TermNode;
import at.jku.risc.stout.urauc.data.atom.ContextVar;
import at.jku.risc.stout.urauc.util.IntList;

public class AntiUnifySystem4V extends AntiUnifySystem {

	public AntiUnifySystem4V(EquationSystem<AntiUnifyProblem> problemSet,
			Substitution sigma) {
		super(problemSet, sigma);
		narrowVariables = true;
	}

	/** TODO: Override and implement rule */
	protected boolean narHO(List<VariableWithHedges> storeQ,
			DebugLevel debugLevel, PrintStream debugOut) {
		boolean updated = false;
		for (int i = storeQ.size() - 1; i >= 0; i--) {
			VariableWithHedges eq = storeQ.get(i);
			Hedge left = eq.getLeft();
			Hedge right = eq.getRight();
			IntList idxL = left.getHoleIdxRec();
			IntList idxR = right.getHoleIdxRec();
			if (idxL.size == idxR.size) {
				boolean conditionOK = true;
				for (int j = idxL.size; conditionOK && --j > 0;) {
					TermNode leftTerm = left.get((int) idxL.values[j]);
					TermNode rightTerm = right.get((int) idxR.values[j]);
					conditionOK = !(leftTerm.getAtom() instanceof ContextVar)
							&& !(rightTerm.getAtom() instanceof ContextVar);
					left = leftTerm.getHedge();
					right = rightTerm.getHedge();
				}
				if (conditionOK) {
					// TODO: Decompose context
					updated = true;
				}
			}
		}
		return updated;
	}

	/** TODO: Override and implement rule */
	protected boolean narFO(List<VariableWithHedges> storeS,
			DebugLevel debugLevel, PrintStream debugOut) {
		boolean updated = false;
		for (int i = storeS.size() - 1; i >= 0; i--) {
			VariableWithHedges eq = storeS.get(i);
			// Notice eq.getX().size > 0 for some X in {Left, Right} by Clr-H
			if (eq.getLeft().size() == eq.getRight().size()) {
				// Implement:
				// Decompose horizontally AND CHECK that all elements are
				// TERMS!!! (Attention Term variables are instances of Hedge
				// variables)
				// ...
				// if (conditionFulfilled) updated = true;
			}
		}
		return updated;
	}

}
