package at.jku.risc.stout.urauc.util;

public class Pair<T1, T2> {
	public final T1 x;
	public final T2 y;

	public Pair(T1 x, T2 y) {
		this.x = x;
		this.y = y;
	}

	@Override
	public int hashCode() {
		return (31 * x.hashCode()) ^ y.hashCode();
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this)
			return true;
		if (!(obj instanceof Pair<?, ?>))
			return false;
		Object x2 = ((Pair<?, ?>) obj).x;
		Object y2 = ((Pair<?, ?>) obj).y;
		boolean bx = x == null ? x2 == null : x.equals(x2);
		boolean by = y == null ? y2 == null : y.equals(y2);
		return bx && by;
	}

	@Override
	public String toString() {
		return "(" + x + ", " + y + ")";
	}
}